
// load macro and filter declarations - see section "Makros" below
\INCLUDE{type=pp file="macros.pp"}

=Vorbild::Beitrag::PP - Ein Vorbildartikel fr den Tagungsband

An example article for the proceedings paper.

This article is written in "dual language free style", sometimes
additional subsections, sometimes just additional english paragraphs,
sometimes obvious examples are not translated. Please report any
language problems, you could imagine.

==Autor

Steffen Schwigon (\C<<schwigon@webit.de>>)

Jochen Stenzel (\C<<perl@jochen-stenzel.de>>)

==Bio Steffen Schwigon

Dieser Abschnitt enthlt eine Kurzbiographie (Bio). Beschreibe Dich
kurz in eigenen Worten und dem Stil Deiner Wahl.

This section contains your short biography. Describe yourself with
your own words and with your preferred style.

==Bio Jochen Stenzel

Dieser Abschnitt enthlt die Kurzbiographie (Bio) eines weiteren
Autors. Beschreibe Dich kurz in eigenen Worten und dem Stil Deiner
Wahl.

This section contains the short biography of another author if there
is more than one. Describe yourself with your own words and with your
preferred style.

==Abstract

Der Zweck dieses Textes ist die Prsentation eines korrekten
PerlPoint-Artikels fr die YAPC::EU 2012. Es werden
Gesamtstruktur und wichtige Elemente demonstriert.

Ziel ist es, den Tagungsband der diesjhrigen YAPC::EU "aus
einem Gu" herzustellen. Das Tagungsband-Team wird seine Energien
vorrangig in die Untersttzung der Autoren bei der Erstellung
korrekter Beitrge investieren.

Bei Problemen jeglicher Art bitte an Deinen Betreuer oder an die
anderen freundlichen Helfer bei \C<<questions@yapc2012.de>> wenden.

==Abstract

This article is meant to be a presentation of a correct PerlPoint
contribution to the YAPC::EU 2012. It shows overall structure
and demonstrates some important features.

The main goal is to create the proceedings paper of a piece. The
proceedings paper team will mainly use its energy in supporting the
authors to provide correct contributions.

In case of problems just mail them to your designated sponsor (tutor)
or the other friendly organizers at \C<<questions@yapc2012.de>>.

==Grundregeln

Die Beitrge werden durch uns konvertiert und als je ein Kapitel
eines LateX-Gesamt-Dokumentes eingebunden. Damit sich alle Beitrge
zusammenfgen, hier die wichtigsten Hinweise.

* Der Beitrag ist eine Datei \I<article_AUTORKRZEL.pp>

* Der Beitrag beginnt mit

       =Artikelthemaberschrift

* Alle anderen berschriften sind mindestens eine berschriftenebene
  tiefer, also


       ==berschrift

* Wir liefern eine LaTeX-Umgebung zum Testen mit, in welcher der
  konvertierte Text funktionieren mu. Die Rahmendatei ist \I<main.tex>,
  welche den nach LaTeX konvertierten Artikel importiert und strukturell
  die letztendliche LaTeX-Umgebung simuliert. Um die PerlPoint-Datei zu
  konvertieren, wird von uns folgendes Kommando verwendet:

<<EOC
       make article_sts72.tex
EOC

* Wer kein \C<make> hat, muss folgendes tippen (ohne die Zeilenumbrche):

<<EOC
       pp2latex
          --prolog=ppprolog.inc
          --activeContents
          --section-sequence "section"
          --section-sequence "subsection"
          --section-sequence "subsubsection"
          --section-sequence "paragraph"
          article_sts72.pp
          | perl ppfilter.pl > article_sts72.tex
EOC

* Zustzliche Dateien (z.B. Grafiken) mssen in genau einem getrennten
  Unterverzeichnis abgelegt werden, z.B. bestehend aus dem
  Autorenkrzel. Im vorliegenden Beispielartikel wurde \C<sts72>
  verwendet.

* Grafiken sollten im Format \BX<PNG> eingebunden werden.

Der vorliegende Artikel dient als Beispiel fr einen korrekten Artikel
und demonstriert wichtige PerlPoint-Elemente.

==Main rules

The contributions are converted and included as single sections within
our LaTeX main document. For nicely fitting all contributions
together, here are the most important rules.

* The contribution is a file \I<article_AUTORKRZEL.pp>

* The contribution starts with

       =Main topic of the article

* All other headlines are at least one level deeper, i.e.

       ==Headline

* We provide a latex environment in which the converted text has
  to work. The main document is \I<main.tex>, which imports the converted
  article and simulates our final LaTeX environment. To convert the POD
  file the following command is used (without linebreak):

<<EOC
       pp2latex --prolog=prolog.inc article_sts72.pp
         | perl filter.pl > article_sts72.tex
EOC

* Additional files (e.g., images) have to be provided within a
  separate sub directory, e.g., named like your AUTHORMNEMONIC. In the
  current example I use the sub directory C<sts72>.

* Images should be embedded as \BX<PNG>.

The current article is an example for a correct contribution and
demonstrates some important PerlPoint features.

==Sonderzeichen ~ Optionale Kurzfassung

In PerlPoint kann man alle Zeichen direkt verwenden. Es gibt nur fnf
Ausnahmen (die Maskierungssyntax bitte der PerlPoint-Vorlage, \I<nicht>
dem fertigen Dokument entnehmen!):

# Ein \I<Backslash> mu durch einen weiteren Backslash
  geschtzt werden, da der einfache Backslash
  Sonderbedeutungen maskiert: \C<\\>.

# Ein \I<Grer-Zeichen> (\C<\>>) mu geschtzt werden, wenn
  es \I<innerhalb von Tags oder Makros> verwendet wird,
  damit PerlPoint das Tag/Makro nicht "vorfristig" schliet:
  \C<$a=\I<2\B<\>>1> ? "all right" : "oops">.

# Ein \I<Dollar-Zeichen vor einem direkt folgenden Text>
  mu man schtzen, falls man eine gleichnamige
  PerlPoint-Variable definiert hat. Andernfalls ersetzt
  PerlPoint die Variable durch ihren Wert: \$text.

# \I<Eine Tilde in einer berschrift> mu man schtzen,
  da sie in PerlPoint die ausfhrliche Fassung von einer
  optionalen Kurzfassung der berschrift trennt; siehe berschrift
  zu diesem Kapitel.

# Das \I<erste Zeichen eines \B<Text>-Absatzes> mu man mit
  einem vorangestellten Backslash schtzen, wenn es in der
  folgenden Tabelle aufgefhrt ist. \I<Alternativ kann man
  jede Textzeile mit einem Punkt (\C<.>) beginnen und muss
  sich dann um die folgende Tabelle keine Gedanken mehr machen.>

@|||
Name          ||| Zeichen ||| Bedeutung
AT            ||| @       ||| leitet Tabellen ein
Bindestrich   ||| -       ||| trennt aufeinanderfolgende Beispiel-Paragraphen
Dollarzeichen ||| $       ||| \C<$var> beschreibt eine Variable
Doppel-Pipe   ||| ||      ||| leitet ein Paragraphenfilter ein
Doppel-Slash  ||| //      ||| leitet einen Kommentar ein
Doppelpunkt   ||| :       ||| leitet einen Definitionspunkt ein
Fragezeichen  ||| ?       ||| leitet eine Bedingung ein
Gartenzaun    ||| #       ||| leitet einen numerierten Listenpunkt ein
Grer-Als    ||| >       ||| Listeneinrckung
Istgleich     ||| =       ||| leitet eine berschrift ein
Kleiner-Als   ||| <       ||| Listenausrckung
Stern         ||| *       ||| leitet einen Bullet-Listenpunkt ein
Tilde         ||| ~       ||| leitet ein Subdokument (sog. "Docstream") ein

==Special characters ~ optional short variant

In PerlPoint you can use nearly all characters directly. There are
only five exceptions (see the PerlPoint source code for the syntax):

# A \I<backslash> has to be escaped with another backslash: \C<\\>.

# A \I<Greater-than> (\C<\>>) has to be escaped if it appears
  \I<inside of tags or macros>:
  \C<$a=\I<2\B<\>>1> ? "all right" : "oops">.

# A \I<dollar sign immediately followed by text>
  must be escaped, if a PerlPoint variable with the same name is
  defined and you don't want their value but the text: \$text.

# A \I<tilde in a headline> has to be ascaped,
  because it divides a headline into a long and an optional short
  variant; see the headline of this chapter.

# The \I<very first character of a \B<text> block> has to be escaped, if it
  is listed in the following table. \I<Alternatively one can begin each text
  paragraph with a dot, which allows to ignore the table.>

@|||
Character ||| Meaning
@       ||| introduces tables
-       ||| divides successive example paragraphs
$       ||| \C<$var> describes a variable
||      ||| starts a paragraph filter
//      ||| starts a comment
:       ||| starts a definition point
?       ||| starts a condition
#       ||| starts a numerated list item
>       ||| list indent
=       ||| starts a headline
<       ||| list unindent (I mean the opposite of indent)
*       ||| introduces bullet list item
~       ||| introduces sub document (so called "docstream")

==Index

Im folgenden Abschnitt (nach der englischen bersetzung) sind
beispielhaft viele Wrter fr den Index markiert. Die markierten
Wrter werden im Index am Ende des Dokumentes aufgelistet. Fr die
Markierung eines Worts fr den Index wird folgendes Kommando
verwendet:

<<EOC
 \X<Indexwort>
EOC

In the following paragraph many words are marked for the index. The
marked words are listed in the index at the end of the
document. Please use the macro

<<EOC
 \X<Indexword>
EOC

Achtung: \I<Index-Tags mssen in einer Tag/Makro-Verschachtelung immer am
weitesten innen stehen (\C<\\C<\\X<text\>\>>, nicht \C<\\X<\\C<text\>\>>).>

Please note: \I<In case of nested macros the index tags must be
used at the innermost place: (\C<\\C<\\X<text\>\>>, but not
\C<\\X<\\C<text\>\>>).>

* Der \X<Scheik> von \X<Alessandria>, \XOM<Ali | Banu, Ali>\X<Ali Banu>,
war ein \XO<sonderbar>sonderbarer \X<Mann>; wenn er morgens durch die
Straen der Stadt ging, angetan mit einem \X<Turban>, aus den
\X<kstlich>sten \X<Kaschmir>s gewunden, mit dem
\X<Festkleide> und dem reichen \X<Grtel>, der
\X<fnfzig> \X<Kamele> wert war, wenn er einherging
langsamen, gravittischen Schrittes, seine \X<Stirn>e in
finstere Falten gelegt, seine \X<Augenbrauen> zusammengezogen, die
\X<Augen> niedergeschlagen und alle fnf Schritte \X<gedankenvoll>
seinen langen, schwarzen Bart streichend; wenn er so hinging nach der
\X<Moschee>, um, wie es seine \X<Wrde> forderte, den \X<Glubige>n
\X<Vorlesungen> ber den \X<Koran> zu halten: da blieben die Leute auf
der Strae stehen, schauten ihm nach und sprachen zueinander: "Es ist
doch ein schner, stattlicher Mann, und reich, ein reicher \X<Herr>",
setzte wohl ein anderer hinzu, "sehr reich; hat er nicht ein
\X<Schlo> am \X<Hafen von Stambul>?  Hat er nicht \X<Gter> und
\X<Felder> und viele tausend Stck \X<Vieh> und viele \X<Sklaven>?"

==Tabelle / Tables

@|
Sprache   | Eine Nummer  | Weitere Zahlen | Noch etwas
Perl      | 1.0          | 2.1           | 3.2
Python    | 4            | 5             | 6
Ruby      | 7            | 8             | 9

==(Code-)Beispiele / Code examples

Beispielblcke knnen einfach durch Einrcken oder \I<verbatim> als
\C<<<EOF>-Blcke erzeugt werden.

Use \I<verbatim> by simply indenting text or use \C<<<EOF> blocks.

Ein schicke Beispiel-Zahlenkolonne mit \I<verbatim> / a nice column of
figures via \I<verbatim>:

 040002 45221110
 040002 45221120
 040002 45221160        (!)
 040002 23221110
 040003 45221110
 040003 45221120
 usw.

Verbatime Variante fr die gleiche Zahlenkolonne / the same column via
\C<<<EOF>:

<<EOC
 040002 45221110
 040002 45221120
 040002 45221160        (!)
 040002 23221110
 040003 45221110
 040003 45221120
 usw.
EOC

Der Unterschied zwischen beiden Varianten liegt darin, da in der
ersten Variante weiter geparst wird; in der zweiten nicht.

Both variants work differently: the first will still be parsed by
perlpoint, the second will not.

==Grafiken / Images

Bilder knnen grundstzlich in verschiedenen Formaten eingebettet
werden. Fr den Tagungsband bitten wir aber darum, \IB<ausschlielich
\X<PNG>-Grafiken> zu verwenden.

Images can be included. Please use only PNG for the proceedings paper.

Hier ein Bild, in Originalgre und zentriert  / An image, original
size, centred.

<<EOC
  \IMAGE{src="sts72/hype.png"}
EOC

\IMAGE{src="sts72/hype.png"}

Hier das gleiche Bild, zentriert und auf 25% der Textbreite skaliert /
The same image, centred and scaled to 25% of textwidth:

<<EOC
  \IMAGE{width="25%" src="sts72/hype.png"}
EOC

\IMAGE{width="25%" src="sts72/hype.png"}

==Aufzhlungen / Enumerations

Sprachen:

# Perl

# Python

# Ruby

Use mehr von diesen:

* strict

* warnings

* diagnostics

==Verbatim Sourcecode

<<EOC
package Lamebrain::Categorization;

use strict;
use warnings;

use Lamebrain::Class;
use base 'Lamebrain::Class';

sub pre_init  {
  my $self   = shift;
  $self->SUPER::pre_init (@_);
  $self->lockfile ('/tmp/lamebrain_categorization.lck');
  $self->verbose (1);
}

sub learn {
  my $self = shift;

  return unless $self->lock;
  my $ds = new LibCPV::Categorizer::DocumentSet
   ({
     show_stats           => $self->dsopts_show_stats,
     filter_min_cpvs      => $self->dsopts_filter_min_cpvs,
     filter_max_cpvs      => $self->dsopts_filter_max_cpvs,
     filter_load_offset   => $self->dsopts_filter_load_offset,
     filter_load_max_docs => $self->dsopts_filter_load_max_docs
    });
  $ds->add_docs_from_dir ($self->opts_learner_docdir);

  my $l = new LibCPV::Categorizer
   ({
     document_set         => $ds,
     learner_rootdir      => $self->opts_learner_rootdir,
     max_docs_per_learner => $self->opts_max_docs_per_learner,
     ks_params            => {
                              tfidf_weighting =>
                              $self->ksopts_tfidf_weighting,

                              features_kept   =>
                              $self->ksopts_features_kept
                             },
     learner_params       => {
                              threshold       =>
                              $self->learneropts_threshold
                             },
     learner_class        => $self->opts_learner_class
    });
  if ($self->clean_before_learn) {
    my $cmd =
     'rm -fr '.
      $self->opts_learner_rootdir.'/'.$self->opts_learner_class;
    print STDERR $cmd."\n" if $self->verbose;
    system ($cmd);
  }
  print STDERR "Learn, Forrest, learn ...!\n" if $self->verbose;
  $l->train;
  $self->unlock;
}

1;
EOC

==Makros

Im Rahmen unserer CD-Produktionsumgebung sind PerlPoint-Makros definiert, die
auch Autoren zur Verfgung stehen. Dazu ist das beiliegende Definitionsfile wie
am Anfang dieser Vorlage gezeigt einzubinden:

In our production environment we defined some PerlPoint macros that you
can use as well. Include the definition file as shown in the beginning of
this document (see source code):

<<EOC
  \INCLUDE{type=pp file="macros.pp"}
EOC

Die zur Verfgung stehenden Makros knnen \C<macros.pp> und der folgenden
Tabelle entnommen werden.

The available macros are listed in the following table:

||c||@##
Makro / macro      ## Beschreibung / description          ## Beispiel / example
\BC<\\BU>          ## \C<\\B<\\U<...\>\>>-Shortcut        ## \C<\\BU<text\>>
\BC<\\BX>          ## \C<\\B<\\X<...\>\>>-Shortcut        ## \C<\\BX<text\>>
\BC<\\BC>          ## \C<\\B<\\C<...\>\>>-Shortcut        ## \C<\\BC<text\>>
\BC<\\CX>          ## \C<\\C<\\X<...\>\>>-Shortcut        ## \C<\\CX<text\>>
\BC<\\BCX>         ## \C<\\B<\\C<\\X<...\>\>\>>-Shortcut  ## \C<\\BCX<text\>>
\BC<\\IB>          ## \C<\\I<\\B<...\>\>>-Shortcut        ## \C<\\IB<text\>>
\BC<\\IX>          ## \C<\\I<\\X<...\>\>>-Shortcut        ## \C<\\IX<text\>>
\BC<\\IBX>         ## \C<\\I<\\B<\\X<...\>\>\>>-Shortcut  ## \C<\\IBX<text\>>
\BC<\\URL>         ## Link (Option a=Adresse)             ## \C<\\URL{a="http://perl.com"}<News\>>
\BC<\\URLT>        ## Link (Body=Adresse)                 ## \C<\\URLT<perl.com\>>
\BC<\\MAILTO>      ## Mail-Link (Body=Adresse)            ## \C<\\MAILTO<p@mail.de\>>
\BC<\\MAIL>        ## Mail-Link (Option addr=Adresse)     ## \C<\\MAIL{addr="p@mail.de"}<person\>>
\BC<\\XO>          ## versteckter Indexeintrag            ## \C<\\XO<entry\>>
\BC<\\XOM>         ## mehrere versteckte Indexeintrge    ## \C<\\XOM<entry1 | entry2\>>
\BC<\\CENTER>      ## zentrierter Text                    ## \C<\\CENTER<centered\>>
\BC<\\CENTER_ON>   ## Zentrierung an                      ## \C<\\CENTER_ON>
\BC<\\CENTER_OFF>  ## Zentrierung aus                     ## \C<\\CENTER_OFF>
\BC<\\INDENT>      ## eingerckter Text                   ## \C<\\INDENT<indented\>>
\BC<\\INDENT_ON>   ## neue Einrckungsebene erffnen      ## \C<\\INDENT_ON>
\BC<\\INDENT_OFF>  ## Einrckungsebene schlieen          ## \C<\\INDENT_OFF>
\BC<\\SMALL>       ## Text in kleinem Font                ## \C<\\SMALL<small text\>>
\BC<\\RED>         ## roter Text                          ## \C<\\RED<colored\>>
\BC<\\GREEN>       ## grner Text                         ## \C<\\GREEN<colored\>>
\BC<\\BLUE>        ## blauer Text                         ## \C<\\BLUE<colored\>>
\BC<\\CPAN_MODULE> ## Modul-Link und -Indexeintrag        ## \C<\\CPAN_MODULE<Event\>>
\BC<\\DATE>        ## Datum und Zeit                      ## \C<\\DATE>
\BC<\\COPYRIGHT>   ## (c)-Zeichen                         ## \C<\\COPYRIGHT>
\BC<\\FN>          ## Funoten-Definition                 ## \C<\\FN{"fn"}<note\>>
\BC<\\FNR>         ## Verweis auf eine Funote            ## \C<\\FNR{"fn"}>
\BC<\\OREF>        ## Ziel vorhanden ? Link : Text        ## \C<\\OREF{n=chapter}<chapter\>>

\I<Hinweis:> \I<Komplexe Makros wie \C<\\XOM> und \C<\\URLT> knnen
die Freischaltung eingebetteten Perl-Codes im Aufruf von \C<pp2latex>
erfordern. Das Makefile bietet eine entsprechende
Konfigurationsmglichkeit an. Ohne Freischaltung werden solche Makros
(und damit markierter Text) aus Sicherheitsgrnden ignoriert.>

\I<Note:> \I<complex macros like \C<\\XOM> and<\\URLT> might
need an activation of embedded Perl code in the call of \C<pp2latex>.
See the Makefile for the corresponding configuration. Without this
activation those macros are ignored for security reasons.

==Bibliographie / Bibliography

# Wilhelm Hauff. \I<Mrchen-Almanach auf das Jahr
1827>. Project Gutenberg, 2003. \URLT<http://gutenberg.net>.

# Free Software Foundation. \I<GNU's not Unix.> \URLT<http://www.gnu.org>

# Sabine Mustermann. \I<The Example Manual -
Doing by Learning.> Addison-Snipes, Writing, Massachusetts, 1991.

# D. E. Knudson. \I<1966 World Gnus Almanac.>

# Charles Zomtec, Inc. \I<Zomtec.> Green Bottle, Oregon, 2001.

# German Perl Workshop. \I<German Perl Workshop Website.>
\URLT<http://www.perl-workshop.de>
